/// 时间选择器 所显示样式
/// 16 种时间样式
///
enum DateMode {
  /// 【yyyy-MM-dd HH:mm:ss】年月日时分秒
  YMDHMS,

  /// 【yyyy-MM-dd HH:mm】年月日时分
  YMDHM,

  /// 【yyyy-MM-dd HH】年月日时
  YMDH,

  /// 【yyyy-MM-dd】年月日
  YMD,

  /// 【yyyy-MM】年月
  YM,

  /// 【yyyy】年
  Y,

  /// 【MM-dd HH:mm:ss】月日时分秒
  MDHMS,

  /// 【MM-dd HH:mm】月日时分
  MDHM,

  /// 【MM-dd HH:mm】月日时
  MDH,

  /// 【MM-dd】月日
  MD,

  /// 【HH:mm:ss】时分秒
  HMS,

  /// 【HH:mm】时分
  HM,

  /// 【mm:ss】分秒
  MS,

  /// 【ss】秒
  S,

  /// 【MM】月
  M,

  /// 【HH】时
  H,
}

